<?php

namespace catchAdmin\api\controller;

use catcher\base\CatchRequest as Request;
use catcher\CatchResponse;
use catcher\base\CatchController;
use \think\facade\Db;

class Api extends CatchController
{
    /**
     * 获取所有用户列表
     * @time 2022年06月09日 14:22
     */
    public function getUserList(){
     
        if (!isset($_GET['imei']) ||  $_GET['imei']=='') {
            json_fail('缺少设备IMEI号参数');
        }
        //检测imei号是否在数据库中

        $list=Db::table('users')->select();
        //请求成功返回数据
        json_success('获取成功',$list);
    }

    /**
     * 获取所有风场风机
     * @time 2022年06月09日 14:22
     */
    public function getWindList(){
     
        if (!isset($_GET['imei']) ||  $_GET['imei']=='') {
            json_fail('缺少设备IMEI号参数');
        }
        //检测imei号是否在数据库中

        $list=Db::table('wind')->field("id,name,number")->select();
        foreach($list as $val){
            $val['fan_list']=Db::table('fan')->where('wind_id',$val['id'])->field("id,wind_id,number")->select();
        }
        //请求成功返回数据
        json_success('获取成功',$list);
    }

    
}