<?php
/*
 * @Descripttion: 
 * @version: 1.0.0
 * @Author: likang
 * @Date: 2022-05-27 13:34:31
 * @LastEditors: likang
 * @LastEditTime: 2022-07-09 14:43:53
 */

namespace catchAdmin\wind\model;

use catchAdmin\api\Listen;
use catcher\base\CatchModel as Model;
use think\facade\Db;
use catchAdmin\wind\model\get\FanGet;
use catchAdmin\wind\model\search\FanSearch;
use catchAdmin\permissions\model\DataRangScopeTrait;

class Fan extends Model
{
    use Listen;
    use DataRangScopeTrait;
    use FanGet;
    use FanSearch;
    // 表名
    public $name = 'fan';
    // 数据库字段映射
    public $field = array(
        'id',
        // 风厂的id
        'wind_id',
        // 编号
        'number',
        'fan_model',
        'out_date',
        'supplier',
        'longitude',
        'latitude',
        'info',
        'address',
        // 创建人ID
        'creator_id',
        // 创建时间
        'created_at',
        // 更新时间
        'updated_at',
        // 软删除
        'deleted_at',

    );
    public function getList()
    {
        return $this->dataRange()
            ->catchSearch()
            ->append(['wind_name', 'model_name'])
            ->field('*')
            ->catchOrder()
            ->creator()
            ->paginate();
    }
    public function getFanList()
    {
        return $this->dataRange()
            ->catchSearch()
            ->field('id as value,number as name')
            ->catchOrder()
            ->select();
    }
    //根据风场的id,获取风机的机位号
    public function getFanListByWindId($wind_id)
    {

        $data = $this->where('wind_id', $wind_id)->select();
        return $data;
    }
    /**
     * 风机下发内容
     */
    public function addContent(&$obj)
    {

        $data = null;
        $content = null;
        $data = [
            'id' => intval($obj->id),
            'wnum' => Wind::where('id', $obj->wind_id)->value('number'),
            'number' => intval($this->number),
        ];
        $content['data'] = $data;
        $content['type'] = 'Fan';
        return  $content;
    }
}
